"""small change and mat view

Revision ID: d2c33dee079c
Revises: 06605c625998
Create Date: 2025-04-22 10:27:25.322827

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = 'd2c33dee079c'
down_revision: Union[str, None] = '06605c625998'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    """Upgrade schema."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('product_expected_values',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('product_id', sa.Integer(), nullable=True),
    sa.Column('expected_value', sa.Float(), nullable=True),
    sa.Column('created_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('deleted_at', sa.DateTime(timezone=True), nullable=True),
    sa.ForeignKeyConstraint(['product_id'], ['tcgplayer_products.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_product_expected_values_id'), 'product_expected_values', ['id'], unique=False)
    op.execute("""
        CREATE MATERIALIZED VIEW IF NOT EXISTS most_recent_tcgplayer_price AS
        SELECT DISTINCT ON (product_id) *
        FROM public.tcgplayer_price_history
        ORDER BY product_id, date DESC;
    """)
    op.execute("""
        CREATE UNIQUE INDEX IF NOT EXISTS idx_most_recent_tcgplayer_price_product_id
        ON most_recent_tcgplayer_price (product_id);
    """)
    # ### end Alembic commands ###


def downgrade() -> None:
    """Downgrade schema."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_product_expected_values_id'), table_name='product_expected_values')
    op.drop_table('product_expected_values')
    op.execute("DROP INDEX IF EXISTS idx_most_recent_tcgplayer_price_product_id;")
    op.execute("DROP MATERIALIZED VIEW IF EXISTS most_recent_tcgplayer_price;")
    # ### end Alembic commands ###
